<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 45.50</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">DevCamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">LinhLT</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="index.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order List</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index3.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Order Filter</h1>
          </div>
          
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Danh sách đơn hàng</h2>
        
        <div class = "container jumbotron">
          <div class="row">
            <label class = "col-sm-2 col-form-label">Trạng thái order</label>
            <div class = "col-sm-3">
                <select id="select-order-status" class = "form-control">
                    <option value="all">(All)</option>
                    <option value="open">Open</option>
                    <option value="confirmed">Confirmed</option>
                    <option value="cancel">Cancel</option>
                </select>
            </div>
            <label class = "col-sm-2 col-form-label">Loại pizza</label>
            <div class = "col-sm-3">
                <select id="select-pizza" class = "form-control">
                    <option value="all">(All)</option>
                    <option value="Hawaii">Hawaii</option>
                    <option value="Bacon">Bacon</option>
                    <option value="Seafood">Seafood</option>
                </select>
            </div>
            <button class="btn btn-info col-sm-2" id="btn-filter-orders">Lọc</button>
          </div>
          
        </div>
        <table class="table table-bordered table-striped table-hover" id="order-table">
          <thead>
            <tr>
              <th>Order Code</th>
              <th>Kích cỡ combo</th>
              <th>Loại pizza</th>
              <th>Nước uống</th>
              <th>Thành tiền</th>
              <th>Họ và tên</th>
              <th>Số điện thoại</th>
              <th>Trạng thái</th>
              <th>Chi tiết</th>
            </tr>
        </table>
      </div>

    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0.0
    </div>
    <strong>Copyright &copy; 2023 <a href="">DevCamp 120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<script>
  "use strict";
$(document).ready(function() {
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gREQUEST_STATUS_OK = 200;
  const gREQUEST_CREATE_OK = 201; // status 201 tao thanh cong
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
  // base url API
  const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

  var gOrdersArr =[];
  const gCOLUMN_CODE = 0;
  const gCOLUMN_COMBO = 1;
  const gCOLUMN_PIZZA = 2;
  const gCOLUMN_DRINK = 3;
  const gCOLUMN_AMOUNT = 4 ;
  const gCOLUMN_NAME = 5;
  const gCOLUMN_PHONE = 6;
  const gCOLUMN_ORDER_STATUS = 7;
  const gCOLUMN_DETAIL = 8;

  const gUSER_COL = ["orderCode","kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","detail"]
  
  // khởi tạo data table  - chưa có data
  var gOrderTable = $("#order-table").DataTable( {
    // Khai báo các cột của datatable
    "columns" : [
        { "data" : gUSER_COL[gCOLUMN_CODE] },
        { "data" : gUSER_COL[gCOLUMN_COMBO] },
        { "data" : gUSER_COL[gCOLUMN_PIZZA] },
        { "data" : gUSER_COL[gCOLUMN_DRINK] },
        { "data" : gUSER_COL[gCOLUMN_AMOUNT] },
        { "data" : gUSER_COL[gCOLUMN_NAME] },
        { "data" : gUSER_COL[gCOLUMN_PHONE] },
        { "data" : gUSER_COL[gCOLUMN_ORDER_STATUS] },
        { "data" : gUSER_COL[gCOLUMN_DETAIL] }
    ],
    // Ghi đè nội dung của cột action, chuyển thành button chi tiết
    "columnDefs": [ 
    {
        "targets": gCOLUMN_DETAIL,
        "defaultContent": "<button class='info-order btn btn-info'>Chi tiết</button>"
    }]
  });
  
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();
  //gán sự kiện cho nút filter
  $("#btn-filter-orders").click(function(){
    onBtnFilterOrderClick();
  })
  // gán click event handler cho button chi tiet
  $("#order-table").on("click", ".info-order", function() {
    onButtonChiTietClick(this); // this là button được ấn
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  // hàm chạy khi trang được load
  function onPageLoading() {
    // lấy data từ server
    $.ajax({
      url: gBASE_URL,
      type: "GET",
      dataType: 'json',
      success: function(responseObject){
        //debugger;
        gOrdersArr = responseObject;
        loadDataToTable(responseObject);
      },
      error: function(error){
        console.assert(error.responseText);
      }
    });
  }
  //hàm xử lý nút sự kiện filter click
  function onBtnFilterOrderClick(){
    var vFilterObj = {
      trangThai:"",
      loaiPizza: ""
    };
    //b1: thu thập dữ liệu
    thuThapDuLieuFilter(vFilterObj);
    //b2: validate(không có)
    //b3: filter order
    var vOrdersResult = filterOrders(vFilterObj);

    //b4: hiển thị dữ liệu sau khi lọc
    loadDataToTable(vOrdersResult);
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
  // load data to table
  function loadDataToTable(paramResponseObject) {
    //Xóa toàn bộ dữ liệu đang có của bảng
    gOrderTable.clear();
    //Cập nhật data cho bảng 
    gOrderTable.rows.add(paramResponseObject);
    //Cập nhật lại giao diện hiển thị bảng
    gOrderTable.draw();
  }
  //đọc thông tin dùng để lọc
  function thuThapDuLieuFilter(paramFilterObj){
    paramFilterObj.trangThai = $("#select-order-status").val();
    paramFilterObj.loaiPizza = $("#select-pizza").val();
  }
  //hàm lọc theo Filter Object
  function filterOrders(paramFilterObj){
    var vOrders = [];
    vOrders = gOrdersArr.filter(function(paramOrder){
      return ((paramOrder.trangThai == paramFilterObj.trangThai || paramFilterObj.trangThai == "all") 
      && (paramOrder.loaiPizza == paramFilterObj.loaiPizza|| paramFilterObj.loaiPizza == "all"));
    });
    return vOrders;
  }
});
</script>
</body>
</html>
